_C='backups_week_day'
_B='backups_month_day'
_A='backups_time'
from app.helpers.cron_helper import dropbox_upload
import os,shutil
from marshmallow import ValidationError
from app.helpers.error_helper import E
from app import app
from crontab import CronTab
CRONTAB_USER='www-data'
CRONTAB_COMMAND='/docu/venv/bin/python3 /docu/app/helpers/cron_helper.py'
CRONTAB_JOB='docu-backup'
def _validate_time(backups_time):
	A=backups_time.split(':')
	if len(A)!=2:raise ValidationError({_A:[E.VALUE_INVALID]})
	elif not A[0]:raise ValidationError({_A:[E.VALUE_EMPTY]})
	elif not A[0].isdigit():raise ValidationError({_A:[E.VALUE_INVALID]})
	elif not A[1]:raise ValidationError({_A:[E.VALUE_EMPTY]})
	elif not A[1].isdigit():raise ValidationError({_A:[E.VALUE_INVALID]})
	B=int(A[0]);C=int(A[1])
	if B>23:raise ValidationError({_A:[E.VALUE_INVALID]})
	elif C>59:raise ValidationError({_A:[E.VALUE_INVALID]})
	return B,C
def _validate_month_day(backups_month_day):
	A=backups_month_day
	if not A:raise ValidationError({_B:[E.VALUE_EMPTY]})
	elif not A.isdigit():raise ValidationError({_B:[E.VALUE_INVALID]})
	elif int(A)>28:raise ValidationError({_B:[E.VALUE_INVALID]})
	return int(A)
def _validate_week_day(backups_week_day):
	A=backups_week_day
	if not A:raise ValidationError({_C:[E.VALUE_EMPTY]})
	elif not A.isdigit():raise ValidationError({_C:[E.VALUE_INVALID]})
	elif int(A)>7:raise ValidationError({_C:[E.VALUE_INVALID]})
	return int(A)
def backups_schedule_update(**B):
	E='1';G=B.get('backups_enabled','0');F=B.get('backups_policy','daily');H=B.get(_B,E);I=B.get(_C,E);J=B.get(_A,'00:00')
	if G==E:
		D=CronTab(user=CRONTAB_USER)
		try:D.remove_all(comment=CRONTAB_JOB);app.logger.debug('Cron jobs removed.')
		except Exception as A:app.logger.error('Could not remove cron jobs. Error: %s.'%str(A));raise A
		C=D.new(command=CRONTAB_COMMAND,comment=CRONTAB_JOB);K,L=_validate_time(J);C.minute.on(L);C.hour.on(K)
		if F=='weekly':M=_validate_week_day(I);C.dow.on(M)
		elif F=='monthly':N=_validate_month_day(H);C.dom.on(N)
		try:D.write();app.logger.debug('Cron job writed.')
		except Exception as A:app.logger.error('Could not write cron job. Error: %s.'%str(A));raise A
		try:os.system('service cron stop');os.system('service cron start');app.logger.debug('Cron service restarted.')
		except Exception as A:app.logger.error('Could not restart cron. Error: %s.'%str(A));raise A