from cryptography.fernet import Fernet
from app.config import Config
CIPHER_SUITE=Fernet(Config.FERNET_ENCRYPTION_KEY)
class FernetHelper:
	def _create_encryption_key():return Fernet.generate_key()
	@staticmethod
	def encrypt(value):A=CIPHER_SUITE.encrypt(str.encode(value));return A.decode()
	@staticmethod
	def decrypt(value):A=CIPHER_SUITE.decrypt(str.encode(value));return A.decode()
	@staticmethod
	def encrypt_file(path):
		with open(path,'rb')as A:B=A.read()
		C=CIPHER_SUITE.encrypt(B)
		with open(path,'wb')as D:D.write(C)
	@staticmethod
	def decrypt_file(path):
		with open(path,'rb')as A:B=A.read()
		C=CIPHER_SUITE.decrypt(B);return C