_A='%s.%s'
import time
class CacheManager:
	def __init__(A,cache,logger=None):A.cache=cache;A.logger=logger
	def set(A,obj):
		B=obj
		try:
			if A.logger:D=time.time()
			A.cache.set(_A%(B.__tablename__,B.id),B)
			if A.logger:C=time.time()-D;A.logger.debug('Entity set in cache. Elapsed time: %s. Entity: %s.'%(str(C),str(B.__dict__)))
		except Exception as E:
			if A.logger:C=time.time()-D;A.logger.error('Error setting entity in cache. Elapsed time: %s. Entity: %s. Exception: %s.'%(str(C),str(B.__dict__),str(E)))
			raise E
	def get(A,cls,obj_id):
		C=obj_id;B=cls
		try:
			if A.logger:G=time.time()
			D=A.cache.get(_A%(B.__tablename__,C))
			if A.logger:
				E=time.time()-G
				if D:A.logger.debug('Entity is got from cache. Elapsed time: %s. Entity: %s.'%(str(E),str(D.__dict__)))
				else:A.logger.debug('Entity is not found in cache. Elapsed time: %s. Class: %s. Id: %s.'%(str(E),str(B.__dict__),str(C)))
			return D
		except Exception as F:
			if A.logger:A.logger.error('Error getting object from cache. Class: %s. Id: %s. Exception: %s.'%(str(B.__dict__),str(C),str(F)))
			raise F
	def delete(A,cls,obj_id):
		C=obj_id;B=cls
		try:
			if A.logger:E=time.time()
			A.cache.delete(_A%(B.__tablename__,C))
			if A.logger:F=time.time()-E;A.logger.debug('Entity is deleted from cache. Elapsed time: %s. Class: %s. Id: %s.'%(str(F),str(B.__dict__),str(C)))
		except Exception as D:
			if A.logger:A.logger.error('Error deleting entity from cache. Class: %s. Id: %s. Exception: %s.'%(str(B.__dict__),str(C),str(D)))
			raise D
	def clear(A):
		try:
			if A.logger:C=time.time()
			A.cache.clear()
			if A.logger:D=time.time()-C;A.logger.debug('Cache cleared. Elapsed time: %s.'%str(D))
		except Exception as B:
			if A.logger:A.logger.error('Error clearing cache. Exception: %s.'%str(B))
			raise B