from app import db,entity_manager
from app.models.extended_model import ExtendedModel
from app.models.user_model import UserModel
from enum import Enum
class SettingKey(Enum):updates_enabled=0;backups_enabled=1;backups_policy=2;backups_month_day=3;backups_week_day=4;backups_time=5
class SettingModel(ExtendedModel):
	__tablename__='settings';user_id=db.Column(db.BigInteger,db.ForeignKey('users.id'),index=True);setting_key=db.Column(db.Enum(SettingKey),nullable=False);setting_value=db.Column(db.String(255),nullable=True)
	def __init__(A,user_id,setting_key,setting_value=None):A.user_id=user_id;A.setting_key=setting_key;A.setting_value=setting_value
	def to_dict(A,join=None):
		D='user';B=join
		if not A.id:return{}
		if not B:B=[]
		C={'id':A.id,'created_date':A.created_date,'updated_date':A.updated_date,'user_id':A.user_id,'setting_key':A.setting_key.name,'setting_value':A.setting_value or''}
		if D in B:E=entity_manager.select(UserModel,id=A.user_id);C[D]=E.to_dict()
		return C