_G='comment_id'
_F='document_id'
_E='user_id'
_D='created_date'
_C='upload_name'
_B=False
_A=True
from app import db,entity_manager
from app.models.user_model import UserModel
from app.models.extended_model import ExtendedModel
from app.config import Config
UPLOAD_COLUMNS_ORDER_BY=['id',_D,_C]
UPLOAD_COLUMNS_EQUAL=[_E,_F,_G]
UPLOAD_COLUMNS_LIKE=[_C]
class UploadModel(ExtendedModel):
	__tablename__='uploads';user_id=db.Column(db.BigInteger,db.ForeignKey('users.id'),index=_A);document_id=db.Column(db.BigInteger,db.ForeignKey('documents.id'),nullable=_B,index=_A);comment_id=db.Column(db.BigInteger,db.ForeignKey('comments.id'),nullable=_A,index=_A);upload_name=db.Column(db.String(255),nullable=_B,index=_A);upload_mime=db.Column(db.String(255),nullable=_B,index=_A);upload_size=db.Column(db.BigInteger,nullable=_B);upload_rel_path=db.Column(db.String(255),nullable=_B,unique=_A);thumbnail_rel_path=db.Column(db.String(255),nullable=_A,unique=_A)
	def __init__(A,user_id,document_id,upload_name,upload_mime,upload_size,upload_rel_path,comment_id=None,thumbnail_rel_path=None):A.user_id=user_id;A.document_id=document_id;A.comment_id=comment_id;A.upload_name=upload_name;A.upload_mime=upload_mime;A.upload_size=upload_size;A.upload_rel_path=upload_rel_path;A.thumbnail_rel_path=thumbnail_rel_path
	def to_dict(A,join=None):
		D='user';B=join
		if not A.id:return{}
		if not B:B=[]
		C={'id':A.id,_D:A.created_date,'updated_date':A.updated_date,_E:A.user_id,_F:A.document_id,_G:A.comment_id,_C:A.upload_name,'upload_mime':A.upload_mime,'upload_size':A.upload_size,'upload_file':Config.FILE_BASE_URL+str(A.id)+'/','upload_thumbnail':Config.THUMBNAIL_BASE_URL+A.thumbnail_rel_path if A.thumbnail_rel_path else''}
		if D in B:E=entity_manager.select(UserModel,id=A.user_id);C[D]=E.to_dict()
		return C