_F='currency_id'
_E='documents_count'
_D='created_date'
_C='wallet_name'
_B=True
_A=False
from app import db,entity_manager
from app.models.user_model import UserModel
from app.models.currency_model import CurrencyModel
from app.models.extended_model import ExtendedModel
from decimal import Decimal
from app.helpers.money_helper import Money
WALLET_COLUMNS_ORDER_BY=['id',_D,_C,_E]
WALLET_COLUMNS_EQUAL=[_F]
WALLET_COLUMNS_LIKE=[_C]
class WalletModel(ExtendedModel):
	__tablename__='wallets';user_id=db.Column(db.BigInteger,db.ForeignKey('users.id'),index=_B,nullable=_A);currency_id=db.Column(db.BigInteger,db.ForeignKey('currencies.id'),index=_B,nullable=_A);wallet_name=db.Column(db.String(128),index=_B,nullable=_A);wallet_summary=db.Column(db.String(255),nullable=_B);wallet_sum=db.Column(db.Numeric,nullable=_A,default=0);documents_count=db.Column(db.BigInteger,nullable=_A,default=0)
	def __init__(A,user_id,currency_id,wallet_name,wallet_summary=None):A.user_id=user_id;A.currency_id=currency_id;A.wallet_name=wallet_name;A.wallet_summary=wallet_summary;A.wallet_sum=Decimal('0');A.documents_count=0
	def to_dict(A,join=None):
		F='currency';E='user';B=join
		if not A.id:return{}
		if not B:B=[]
		D=entity_manager.select(CurrencyModel,id=A.currency_id);G=Money(A.wallet_sum,D);C={'id':A.id,_D:A.created_date,'updated_date':A.updated_date,'user_id':A.user_id,_F:A.currency_id,_C:A.wallet_name,'wallet_summary':A.wallet_summary or'','wallet_sum':G.money_sum,_E:A.documents_count}
		if E in B:H=entity_manager.select(UserModel,id=A.user_id);C[E]=H.to_dict()
		if F in B:C[F]=D.to_dict()
		return C