_L='/user/image/'
_K='DELETE'
_J='/token/'
_I='/user/'
_H='user_name'
_G='users_count'
_F='PUT'
_E='user_pass'
_D='user_login'
_C='GET'
_B=None
_A='reader'
from flask import g,request
from app import app,entity_manager
from app.decos.halt_deco import halt
from app.decos.auth_deco import auth
from app.models.user_model import UserModel,UserRole
from app import repository_provider
from app.repositories.repository_provider import REPOSITORY_CLASS_USER
from app.helpers.demo_helper import insert_demo_data
@app.route(_I,methods=['POST'],endpoint='user_register')
@halt
def user_register():
	D=request.args.get(_D,'').strip().lower();E=request.args.get(_E,'');F=request.args.get(_H,'').strip();A=UserModel(D,E,F);B=repository_provider.get(REPOSITORY_CLASS_USER);C=B.count()
	if C==0:A.user_role=UserRole.admin
	B.insert(A)
	try:
		C=B.count()
		if C==1:entity_manager.commit();insert_demo_data(entity_manager,A.id)
	except Exception:pass
	return{'user_id':A.id,'mfa_key':A.mfa_key,'mfa_image':A.mfa_image}
@app.route(_J,methods=[_C],endpoint=_D)
@halt
def user_login():A=request.args.get(_D,'').strip().lower();B=request.args.get(_E,'');C=request.args.get('user_totp','').strip();D=request.args.get('token_exp');E=repository_provider.get(REPOSITORY_CLASS_USER);F=E.login(A,B,C,D);return{'user_token':F}
@app.route(_J,methods=[_K],endpoint='user_logout')
@halt
@auth(_A)
def user_logout():A=repository_provider.get(REPOSITORY_CLASS_USER);A.update_token(g.user);return{}
@app.route('/user/<int:user_id>/',methods=[_C],endpoint='user_select')
@halt
@auth(_A)
def user_select(user_id):A=repository_provider.get(REPOSITORY_CLASS_USER);B=A.select(user_id);return{'user':B.to_dict()}
@app.route('/user/pass/',methods=[_F],endpoint='update_pass')
@halt
@auth(_A)
def update_pass():A=request.args.get(_E,'');B=request.args.get('user_pass_new','');C=repository_provider.get(REPOSITORY_CLASS_USER);C.update_pass(g.user,A,B);return{}
@app.route('/user/<int:user_id>/role/',methods=[_F],endpoint='update_role')
@halt
@auth('admin')
def update_role(user_id):A=request.args.get('user_role','').strip();B=repository_provider.get(REPOSITORY_CLASS_USER);C=B.select(user_id);C.user_role=UserRole._member_map_.get(A,A)if A else _B;B.update_role(C,g.user.id);return{}
@app.route(_I,methods=[_F],endpoint='user_update')
@halt
@auth(_A)
def user_update():g.user.user_name=request.args.get(_H,'').strip();g.user.user_job=request.args.get('user_job','').strip()or _B;g.user.user_contacts=request.args.get('user_contacts','').strip()or _B;g.user.user_summary=request.args.get('user_summary','').strip()or _B;A=repository_provider.get(REPOSITORY_CLASS_USER);A.update(g.user);return{}
@app.route('/users/',methods=[_C],endpoint='users_select')
@halt
@auth(_A)
def users_select():A=dict(request.args);B=repository_provider.get(REPOSITORY_CLASS_USER);C=B.select_some(**A);D=B.count(**A);return{'users':[A.to_dict()for A in C],_G:D}
@app.route('/users/count/',methods=[_C],endpoint=_G)
@halt
@auth(_A)
def users_count():A=dict(request.args);B=repository_provider.get(REPOSITORY_CLASS_USER);C=B.count(**A);return{_G:C}
@app.route(_L,methods=['POST'],endpoint='upload_user_image')
@halt
@auth(_A)
def upload_user_image():A='user_image';B=request.files.getlist('user_file')[0]if len(request.files)>0 else _B;C=repository_provider.get(REPOSITORY_CLASS_USER);C.upload_image(g.user,B);return{A:g.user.to_dict()[A]}
@app.route(_L,methods=[_K],endpoint='delete_user_image')
@halt
@auth(_A)
def delete_user_image():A=repository_provider.get(REPOSITORY_CLASS_USER);A.delete_image(g.user);return{}