import pyotp,qrcode
from app.config import Config
from app import app,fm
class MFA:
	def __init__(A,user_login,mfa_key=None):A.user_login=user_login;A.mfa_key=mfa_key or pyotp.random_base32()
	@property
	def mfa_totp(self):A=pyotp.TOTP(self.mfa_key);return A.now()
	@property
	def mfa_image(self):return Config.MFA_BASE_URL+self.mfa_key+Config.MFA_IMAGE_EXT
	@property
	def mfa_image_abs_path(self):return fm.path_join(Config.MFA_BASE_PATH,self.mfa_key+Config.MFA_IMAGE_EXT)
	def create_image(A):
		B=qrcode.QRCode(version=Config.MFA_IMAGE_VERSION,error_correction=qrcode.constants.ERROR_CORRECT_L,box_size=Config.MFA_IMAGE_SIZE,border=Config.MFA_IMAGE_BORDER);B.add_data('otpauth://totp/%s?secret=%s&issuer=%s'%(Config.MFA_REF_APP,A.mfa_key,A.user_login));B.make(fit=Config.MFA_IMAGE_FIT);E=B.make_image(fill_color=Config.MFA_IMAGE_COLOR,back_color=Config.MFA_IMAGE_BACKGROUND)
		try:C=fm.path_join(Config.MFA_BASE_PATH,A.mfa_key+Config.MFA_IMAGE_EXT);E.save(C);app.logger.debug('MFA image has been saved. Path: %s.'%C)
		except Exception as D:app.logger.error('Could not save MFA image. Path: %s. Exception: %s.'%(C,str(D)));raise D
	def delete_image(A):fm.file_delete(fm.path_join(Config.MFA_BASE_PATH,A.mfa_key+Config.MFA_IMAGE_EXT))