import time,qrcode
from app.config import Config
from app import app,fm
class QRCode:
	def __init__(A,logger=None):A.logger=logger
	def create_image(A,document_id):
		C=document_id;D=fm.today;E=fm.path_join(Config.QRCODE_BASE_PATH,D)
		if not fm.path_exists(E):fm.path_create(E)
		F=fm.path_join(D,fm.file_uuid+Config.QRCODE_IMAGE_EXT);G=fm.path_join(Config.QRCODE_BASE_PATH,F)
		try:
			if A.logger:I=time.time()
			B=qrcode.QRCode(version=Config.QRCODE_IMAGE_VERSION,error_correction=qrcode.constants.ERROR_CORRECT_L,box_size=Config.QRCODE_IMAGE_SIZE,border=Config.QRCODE_IMAGE_BORDER);B.add_data(Config.APP_BASE_URL+'document/'+str(C)+'/');B.make(fit=Config.QRCODE_IMAGE_FIT);J=B.make_image(fill_color=Config.QRCODE_IMAGE_COLOR,back_color=Config.QRCODE_IMAGE_BACKGROUND);J.save(G)
			if A.logger:K=time.time()-I;A.logger.debug('QR-code image saved. Elapsed time: %s. Path: %s.'%(str(K),G))
		except Exception as H:A.logger.error('Error creating QR-code. Document_id: %s. Exception: %s.'%(C,str(H)));raise H
		return F