_A='category_id'
from marshmallow import ValidationError
from app.models.category_model import CategoryModel
from app.schemas.category_schema import CategorySchema
from app.repositories.abstract_repository import AbstractRepository
from app.schemas.filter_schema import FilterSchema
from app.helpers.error_helper import E
from app.models.category_model import CATEGORY_COLUMNS_ORDER_BY,CATEGORY_COLUMNS_EQUAL,CATEGORY_COLUMNS_LIKE
class CategoryRepository(AbstractRepository):
	def insert(B,category):A=category;CategorySchema().validate_model(A);B.entity_manager.insert(A)
	def select(C,category_id):
		A=category_id
		if not A:raise ValidationError({_A:[E.VALUE_EMPTY]})
		try:CategorySchema().validate_kwargs(id=A)
		except ValidationError as D:raise ValidationError({_A:D.messages['id']})
		B=C.entity_manager.select(CategoryModel,id=A)
		if not B:raise ValidationError({_A:[E.VALUE_NOT_FOUND]})
		return B
	def update(B,category):A=category;CategorySchema().validate_model(A);B.entity_manager.update(A)
	def delete(B,category):
		A=category
		if A.documents_count>0:raise ValidationError({_A:[E.VALUE_LOCKED]})
		B.entity_manager.delete(A)
	def select_some(B,**A):C=FilterSchema(CATEGORY_COLUMNS_ORDER_BY);C.validate_kwargs(**A);D={B:A[B]for B in FilterSchema._declared_fields};E=B._create_query_params(CATEGORY_COLUMNS_EQUAL,CATEGORY_COLUMNS_LIKE,**A);F=D|E;G=B.entity_manager.select_some(CategoryModel,**F);return G
	def count(A,**B):C=A._create_query_params(CATEGORY_COLUMNS_EQUAL,CATEGORY_COLUMNS_LIKE,**B);D=A.entity_manager.count(CategoryModel,**C);return D