_E='wallet_id'
_D='losses_count'
_C='gains_count'
_B='losses_sum'
_A='gains_sum'
from marshmallow import ValidationError
from app.repositories.abstract_repository import AbstractRepository
from app.helpers.error_helper import E
from datetime import date,timedelta,datetime
import time
from decimal import Decimal
from app import repository_provider
from app.repositories.repository_provider import REPOSITORY_CLASS_CURRENCY
from app.repositories.repository_provider import REPOSITORY_CLASS_WALLET
from app.helpers.money_helper import Money
import platform,psutil
from app.config import Config
import platform,psutil
class ReportRepository(AbstractRepository):
	def insert(A):0
	def select(B,report_id,**C):
		U='indexes_size';T='total_size';S='relations_size';R='entities_count';Q='uploads_count';P='uploads_size';M=report_id;L='/';K='table_name';J='end_date';I='start_date'
		if M==1:
			G=C.get(_E,'').strip();D=C.get(I);F=C.get(J)
			try:D=int(C[I])
			except Exception:raise ValidationError({I:[E.VALUE_INVALID]})
			try:F=int(C[J])
			except Exception:raise ValidationError({J:[E.VALUE_INVALID]})
			V,W,X=B._select_documents_grouped_by_date(G,D,F);Y=B._select_documents_grouped_by_category(G,D,F);Z=B._select_documents_grouped_by_customer(G,D,F);a=B._select_documents_tags(G,D,F);return{'wallet_data':V,'currency_data':W,'documents_data':X,'categories_data':Y,'customers_data':Z,'tags_data':a}
		elif M==2:
			H=B.entity_manager.query("SELECT upload_mime, COUNT('id') AS uploads_count, SUM(upload_size) AS uploads_size FROM uploads GROUP BY upload_mime");N=[]
			for A in H:N.append({'uploads_mimetype':A['upload_mime'],P:A[P],Q:A[Q]})
			H=B.entity_manager.query("SELECT                 t.*,                 pg_relation_size(quote_ident(t.table_name)) AS relations_size,                 pg_total_relation_size(quote_ident(t.table_name)) AS total_size,                 pg_indexes_size(quote_ident(t.table_name)) AS indexes_size             FROM information_schema.tables AS t             WHERE t.table_name IN ('users', 'wallets', 'currencies', 'archives', 'categories', 'customers', 'documents', 'comments', 'tags', 'mentions', 'uploads', 'settings') ;");O=[]
			for A in H:b=B.entity_manager.query("SELECT COUNT('id') AS entities_count FROM "+A[K]);c=next(b)[R];O.append({K:A[K],S:A[S],T:A[T],U:A[U],R:c})
			return{'app':{'timezone':time.tzname[0],'python_version':platform.python_version()},'os':{'os_name':platform.system(),'os_release':platform.release(),'os_version':platform.version()},'ram':{'ram_total':str(psutil.virtual_memory().total),'ram_used':str(psutil.virtual_memory().used),'ram_free':str(psutil.virtual_memory().free)},'hdd':{'hdd_total':str(psutil.disk_usage(L).total),'hdd_used':str(psutil.disk_usage(L).used),'hdd_free':str(psutil.disk_usage(L).free)},'cpu':{'cpu_architecture':' '.join(platform.architecture()),'cpu_type':platform.machine(),'cpu_count':psutil.cpu_count(),'cpu_frequency':int(psutil.cpu_freq()[0])},'db':O,'uploads':N}
	def _get_time_keys(A,start_date,end_date,value):return{datetime.fromtimestamp(A).strftime('%Y-%m-%d'):dict(value)for A in range(start_date,end_date+1,86400)}
	def _select_documents_grouped_by_date(H,wallet_id,start_date,end_date):
		K=end_date;J=start_date;I=wallet_id;G='0.0';L=repository_provider.get(REPOSITORY_CLASS_WALLET);F=L.select(I);C={_E:F.id,'wallet_name':F.wallet_name,'wallet_sum':F.wallet_sum,_A:Decimal(G),_C:0,_B:Decimal(G),_D:0};M=repository_provider.get(REPOSITORY_CLASS_CURRENCY);D=M.select(F.currency_id);N={'currency_id':D.id,'currency_code':D.currency_code,'currency_name':D.currency_name,'fraction_digits':D.fraction_digits};O=H.entity_manager.query("SELECT                 w.id AS wallet_id,                 w.wallet_name AS wallet_name,                 w.wallet_sum AS wallet_sum,                 c.id AS currency_id,                 c.currency_name AS currency_name,                 c.currency_code AS currency_code,                 c.fraction_digits AS fraction_digits,                 sum(case when document_sum > 0 then document_sum else 0 end) as gains_sum,                 sum(case when document_sum < 0 then document_sum else 0 end) as losses_sum,                 sum(case when document_sum > 0 then 1 else 0 end) as gains_count,                 sum(case when document_sum < 0 then 1 else 0 end) as losses_count,                 to_char(to_timestamp(d.closed_date)::date, 'YYYY-MM-DD') AS dt             FROM documents AS d             JOIN wallets AS w ON w.id = d.wallet_id             JOIN currencies AS c ON c.id = w.currency_id             WHERE d.document_status='done'             AND d.document_sum != 0             AND w.id=%s             AND d.closed_date>=%s             AND d.closed_date<=%s             GROUP BY w.id, c.id, dt"%(I,J,K));P={_A:Decimal(G),_C:0,_B:Decimal(G),_D:0};A=H._get_time_keys(J,K,P)
		for E in O:B=E['dt'];A[B][_A]=Money(E[_A],D).money_sum;A[B][_C]=E[_C];A[B][_B]=E[_B];A[B][_D]=E[_D];C[_A]=Money(C[_A]+A[B][_A],D).money_sum;C[_C]+=A[B][_C];C[_B]=Money(C[_B]+A[B][_B],D).money_sum;C[_D]+=A[B][_D]
		return C,N,[{'date':B}|A[B]for B in A]
	def _select_documents_grouped_by_category(F,wallet_id,start_date,end_date):
		E='category_name';D='category_id';G=F.entity_manager.query("SELECT                 w.id AS wallet_id,                 (case when d.category_id IS NOT NULL then d.category_id else 0 end) AS category_id,                 (case when d.category_id IS NOT NULL then c.category_name else '' end) AS category_name,                 sum(case when document_sum > 0 then document_sum else 0 end) as gains_sum,                 sum(case when document_sum < 0 then document_sum else 0 end) as losses_sum,                 sum(case when document_sum > 0 then 1 else 0 end) as gains_count,                 sum(case when document_sum < 0 then 1 else 0 end) as losses_count             FROM documents AS d             JOIN wallets AS w ON w.id = d.wallet_id             LEFT JOIN categories AS c ON c.id = d.category_id             WHERE d.document_status='done'             AND d.document_sum != 0             AND w.id=%s             AND d.closed_date>=%s             AND d.closed_date<=%s             GROUP BY w.id, category_id, category_name"%(wallet_id,start_date,end_date));A={}
		for C in G:
			B=C[D]
			if B not in A:A[B]={}
			A[B][E]=C[E];A[B][_A]=C[_A];A[B][_C]=C[_C];A[B][_B]=C[_B];A[B][_D]=C[_D]
		return[{D:B}|A[B]for B in A]
	def _select_documents_grouped_by_customer(F,wallet_id,start_date,end_date):
		E='customer_name';D='customer_id';G=F.entity_manager.query("SELECT                 w.id AS wallet_id,                 (case when d.customer_id IS NOT NULL then d.customer_id else 0 end) AS customer_id,                 (case when d.customer_id IS NOT NULL then c.customer_name else '' end) AS customer_name,                 sum(case when document_sum > 0 then document_sum else 0 end) as gains_sum,                 sum(case when document_sum < 0 then document_sum else 0 end) as losses_sum,                 sum(case when document_sum > 0 then 1 else 0 end) as gains_count,                 sum(case when document_sum < 0 then 1 else 0 end) as losses_count             FROM documents AS d             JOIN wallets AS w ON w.id = d.wallet_id             LEFT JOIN customers AS c ON c.id = d.customer_id             WHERE d.document_status='done'             AND d.document_sum != 0             AND w.id=%s             AND d.closed_date>=%s             AND d.closed_date<=%s             GROUP BY w.id, customer_id, customer_name"%(wallet_id,start_date,end_date));A={}
		for B in G:
			C=B[D]
			if B not in A:A[C]={}
			A[C][E]=B[E];A[C][_A]=B[_A];A[C][_C]=B[_C];A[C][_B]=B[_B];A[C][_D]=B[_D]
		return[{D:B}|A[B]for B in A]
	def _select_documents_tags(F,wallet_id,start_date,end_date):
		E='document_tag';D='document_sum';G=F.entity_manager.query("SELECT                 t.document_tag AS document_tag,                 d.document_sum AS document_sum             FROM tags AS t             JOIN documents AS d ON d.id = t.document_id             JOIN wallets AS w ON w.id = d.wallet_id            WHERE d.document_status='done'             AND d.document_sum != 0             AND w.id=%s             AND d.closed_date>=%s             AND d.closed_date<=%s"%(wallet_id,start_date,end_date));B,C=set(),set()
		for A in G:
			if A[D]>0:B.add(A[E])
			elif A[D]<0:C.add(A[E])
		return{'gains_tags':list(B),'losses_tags':list(C)}
	def update(A):0
	def delete(A):0
	def select_some(A):0
	def count(A,**B):0