_G='category_summary'
_F='category_name'
_E='categories_count'
_D='reader'
_C='GET'
_B='/category/<int:category_id>/'
_A='admin'
from app import app
from app.decos.halt_deco import halt
from app.decos.auth_deco import auth
from flask import g,request
from app.models.category_model import CategoryModel
from app import repository_provider
from app.repositories.repository_provider import REPOSITORY_CLASS_CATEGORY
@app.route('/category/',methods=['POST'],endpoint='category_insert')
@halt
@auth(_A)
def category_insert():B=request.args.get(_F,'').strip();C=request.args.get(_G,'').strip()or None;A=CategoryModel(g.user.id,B,C);D=repository_provider.get(REPOSITORY_CLASS_CATEGORY);D.insert(A);return{'category_id':A.id}
@app.route(_B,methods=[_C],endpoint='category_select')
@halt
@auth(_D)
def category_select(category_id):A=repository_provider.get(REPOSITORY_CLASS_CATEGORY);B=A.select(category_id);return{'category':B.to_dict(join=['user'])}
@app.route(_B,methods=['PUT'],endpoint='category_update')
@halt
@auth(_A)
def category_update(category_id):C=request.args.get(_F,'').strip();D=request.args.get(_G,'').strip()or None;B=repository_provider.get(REPOSITORY_CLASS_CATEGORY);A=B.select(category_id);A.category_name=C;A.category_summary=D;B.update(A);return{}
@app.route(_B,methods=['DELETE'],endpoint='category_delete')
@halt
@auth(_A)
def category_delete(category_id):A=repository_provider.get(REPOSITORY_CLASS_CATEGORY);B=A.select(category_id);A.delete(B);return{}
@app.route('/categories/',methods=[_C],endpoint='categories_select_some')
@halt
@auth(_D)
def categories_select_some():A=dict(request.args);B=repository_provider.get(REPOSITORY_CLASS_CATEGORY);C=B.select_some(**A);D=B.count(**A);return{'categories':[A.to_dict()for A in C],_E:D}
@app.route('/categories/count/',methods=[_C],endpoint=_E)
@halt
@auth(_D)
def categories_count():A=dict(request.args);B=repository_provider.get(REPOSITORY_CLASS_CATEGORY);C=B.count(**A);return{_E:C}