_D=False
_C='\t'
_B='  '
_A=True
from marshmallow import fields,validate
from marshmallow_enum import EnumField
from app.models.user_model import UserRole
from app.schemas.base_schema import BaseSchema
from app.helpers.error_helper import E
import string
class UserSchema(BaseSchema):id=fields.Raw(allow_none=_A,validate=[lambda x:isinstance(x,str)and x.isdigit()and not x.startswith('0')or isinstance(x,int)and x>0]);user_role=EnumField(UserRole,strict=_A,by_value=_A,error=E.VALUE_INVALID);user_login=fields.Str(allow_none=_D,validate=[validate.Length(min=2,max=40),lambda x:x.isalnum()and x.isascii()and x.islower()]);user_pass=fields.Str(allow_none=_A,validate=[validate.Length(min=6),lambda x:not x.isspace()]);pass_hash=fields.Str(allow_none=_D,validate=[validate.Length(equal=128),lambda x:all(A in set(string.hexdigits)for A in x)]);user_name=fields.Str(allow_none=_D,validate=[validate.Length(min=2,max=40),lambda x:not(x.isspace()or _B in x or _C in x)]);user_job=fields.Str(allow_none=_A,validate=[validate.Length(max=40),lambda x:not(not x or x.isspace()or _B in x or _C in x)]);user_contacts=fields.Str(allow_none=_A,validate=[validate.Length(max=255),lambda x:not(not x or x.isspace()or _B in x or _C in x)]);user_summary=fields.Str(allow_none=_A,validate=[validate.Length(max=255),lambda x:not(not x or x.isspace()or _B in x or _C in x)]);token_exp=fields.Raw(allow_none=_A,validate=[lambda x:isinstance(x,str)and x.isdigit()and not x.startswith('0')or isinstance(x,int)and x>0])